svghost/svghost/urls.py
#
# Copyright (C) 2015 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django.conf.urls import url

from .views import *

app_name="svghost"
urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^user/(?P<user_id>[0-9]+)/?$', user_by_id, name='user_by_id'),
    url(r'^u/(?P<user_name>[-A-Za-z0-9_]+)/?$', user_by_name, name='user_by_name'),
    url(r'^upload/?$', upload, name='upload'),
    url(r'^image/(?P<uuid>[-A-Fa-f0-9]+)/?$', image, name='image'),
]

svghost/urls.py
#
# Copyright (C) 2015 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django.conf.urls import url, include
from django.contrib import admin, auth
import django.contrib.auth.views

urlpatterns = [
    url(r'^admin/', include(admin.site.urls)),
    url(r'^login/$', auth.views.login, {'template_name': 'login.htm'}, name='login'),
    url(r'^logout/$', auth.views.logout, name='logout'),
    url(r'^', include('svghost.svghost.urls')),
]

svghost/svghost/models.py
#
# Copyright (C) 2015 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import uuid
from django.db import models
from django.contrib.auth.models import User
from django.db.models import signals

class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    avatar = models.OneToOneField("Image", on_delete=models.SET_NULL, null=True, blank=True)
    can_upload = models.ManyToManyField("ImageType", related_name="uploaders", blank=True)
    can_embed = models.ManyToManyField("ImageType", related_name="embedders", blank=True)

    def __str__(self):
        return "Profile for %s (%s)" % (self.user.email, self.user.username)

    @staticmethod
    def _create(sender, instance, created, **kwargs):
        if created:
            Profile.objects.create(user=instance)

signals.post_save.connect(Profile._create, sender=User)


class File(models.Model):
    uuid = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    basename = models.CharField(max_length=128)
    creation_date = models.DateTimeField(auto_now_add=True)
    owner = models.ForeignKey(User, on_delete=models.CASCADE)
    deleted = models.BooleanField(default=False)
    hidden = models.BooleanField(default=False)

    class Meta:
        abstract = True

    @staticmethod
    def _upload_file(instance, filename):
        return 'images/{1}/{2}'.format(instance.owner.id, instance.uuid)


class Image(File):
    description = models.TextField()
    authors = models.ManyToManyField(User, related_name="all_images", blank=True)
    type = models.ForeignKey("ImageType", on_delete=models.PROTECT)
    license = models.ForeignKey("License", on_delete=models.PROTECT) # Many Many?
    modified_date = models.DateTimeField(auto_now=True)
    image = models.FileField(upload_to=File._upload_file)

    def upload_file(self):
        return File._upload_file(self, self.basename)


class ImageType(models.Model):
    name = models.CharField(max_length=32)
    mime_type = models.CharField(max_length=128)
    text = models.BooleanField()
    priority = models.IntegerField(default=0)
    extensions = models.ManyToManyField("FileExtension")


class FileExtension(models.Model):
    extension = models.CharField(max_length=16)


class Directory(File):
    parent = models.ForeignKey("Directory", on_delete=models.CASCADE, null=True)
    images = models.ManyToManyField("Image")


class License(models.Model):
    short_name = models.CharField(max_length=32)
    description = models.TextField()
    url = models.URLField(null=True, blank=True)


class Comment(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    image = models.ManyToManyField(Image)
    text = models.TextField()

svghost/svghost/forms.py
#
# Copyright (C) 2015 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django import forms
from . import models

class SingleImage(forms.ModelForm):

    class Meta:
        fields = [ 'image' ]
        model = models.Image

svghost/svghost/views.py
#
# Copyright (C) 2015 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django.http import HttpResponse
from django.shortcuts import get_object_or_404, render
from django.utils.translation import ugettext as _
from . import models, forms

def home(request):
    return HttpResponse("Todo")

def _user_profile(request, user):
    context = {
        "profile_user": user,
    }
    return render(request, "svghost/profile.htm", context)

def user_by_id(request, user_id):
    return _user_profile(request, get_object_or_404(models.User, id=user_id))

def user_by_name(request, user_name):
    return _user_profile(request, get_object_or_404(models.User, username=user_name))

def upload(request):
    if request.method == "POST":
        form = forms.SingleImage(request.POST, request.FILES)
        if form.is_valid():
            new_file = models.Image(image = request.FILES['image'])
            new_file.save()
            return HttpResponseRedirect(reverse('svghost:image', uuid=new_file.uuid))
    else:
        form = forms.SingleImage()

    context = {
        "form": form,
    }
    return render(request, "svghost/upload.htm", context)

def image(request, uuid):
    return render(request, "svghost/image.htm")

svghost/svghost/templates/base.htm
{% load i18n %}
<!DOCTYPE html>
<html>
{% block head %}
{% endblock %}
<title>{% block title %}{% endblock %}</title>
</html>
<body>
<nav id="main_nav">
    <ul id="nav_links">
        <li><a href="{% url "svghost:home" %}">{% trans "Home"%}</a></li>
        {% block nav_links %}
        {% endblock %}
    </ul>
    <ul id="nav_breadcrubs">
        {% block nav_breadcrubs %}
        {% endblock %}
    </ul>
    <nav id="nav_menu">
        <span>{% trans "Actions"%}</span>
        <ul>
            {% if user.is_authenticated %}
                <li><a href="{% url "logout" %}">{% trans "Logout"%}</a></li>
                <li><a href="{% url "svghost:upload" %}">{% trans "Upload"%}</a></li>
                {% if user.is_staff or user.is_superuser %}
                    <li><a href="{% url "admin:index" %}">{% trans "Admin"%}</a></li>
                {% endif %}
            {% else %}
                <li><a href="{% url "login" %}">{% trans "Login"%}</a></li>
            {% endif %}
            {% block nav_menu %}
            {% endblock %}
        </ul>
    </nav>
</nav>
<main id="contents">
{% block contents %}
{% endblock %}
</main>
</body>

svghost/svghost/templates/svghost/profile.htm
{% extends "base.htm" %}
{% load i18n %}

{% block nav_menu %}
    {% if perms.auth.user.change or user.is_superuser %}
        <li><a href="{% url "admin:auth_user_change" profile_user.id %}">{% trans "User admin"%}</a></li>
    {% endif %}
{% endblock %}

{% block contents %}
<h1><a href="{% url 'svghost:user_by_name' profile_user.username %}">
{% block title %}{% blocktrans with profile_user.username as username %}{{ username }}'s profile{% endblocktrans %}{% endblock %}
</a></h1>
{% endblock %}

svghost/svghost/templates/svghost/upload.htm
{% extends "base.htm" %}
{% load i18n %}
{% load staticfiles %}

{% block head %}
<script src="{% static 'dropzone/dropzone.min.js' %}"></script>
<link rel="stylesheet" type="text/css" href="{% static 'dropzone/dropzone.min.css' %}"></script>
{% endblock %}

{% block nav_menu %}
    {% if perms.auth.user.change or user.is_superuser %}
        <li><a href="{% url "admin:auth_user_change" profile_user.id %}">{% trans "User admin"%}</a></li>
    {% endif %}
{% endblock %}

{% block contents %}
<form action="{% url "svghost:upload" %}" method="post">
    {% csrf_token %}
    <div class="dropzone" id="dropzone_form" action="{% url "svghost:upload" %}">
        <div class="fallback">
            <input name="image" type="file" />
        </div>
    </div>
    <input type="submit" id="submit" />
</form>

<script type="text/javascript">
    // TODO page for bulk uploads
    Dropzone.options.dropzoneForm = {
        url:                "{% url "svghost:upload" %}",
        autoProcessQueue:   false,
        uploadMultiple:     false,
        parallelUploads:    1,
        maxFiles:           1,
        paramName:          'image',
        acceptedFiles:      'image/*',  // TODO: accept based on db permissions

        init: function()
        {
            var button_submit = document.querySelector("#submit");
            button_submit.style.visibility = "hidden";
            var dropzone_form = this;

            button_submit.addEventListener("click", function() {
                dropzone_form.processQueue();
            });

            this.on("addedfile", function() {
                button_submit.style.visibility = "visible";
                if ( this.files.length > this.maxFiles )
                    this.removeFile(this.files[0]);
            });

        },

        maxfilesexceeded: function(file)
        {
            this.removeFile(this.files[0]);
            this.addFile(file);
        }
    };
</script>
{% endblock %}